/*
 * Copyright (c) 1998 by Toshio Endo, Kenjiro Taura. All rights reserved.
 * Copyright (c) 1998 by Mitsubishi Research Institute.  All rights reserved.
 * Copyright (c) 1998 by Information-technology Promotion Agency.  All rights reserved.
 *
 * THIS MATERIAL IS PROVIDED AS IS, WITH ABSOLUTELY NO WARRANTY EXPRESSED
 * OR IMPLIED.  ANY USE IS AT YOUR OWN RISK.
 *
 * Permission is hereby granted to use or copy this program
 * for any purpose,  provided the above notices are retained on all copies.
 * Permission to modify the code and to distribute modified code is granted,
 * provided the above notices are retained, and a notice that the code was
 * modified is included with the above copyright notice.
 *
 */
/* Endo, June 3, 1999 */

/* Configuration dependent */
/* How to access thread(process) local storage used by SGC. */

#  if defined SGC_TLS_GLOBAL_VARIABLE

#    if defined __MISC_C
struct GC_Thread_Rep *GC_my_envp; /* if included by misc.c */
#    else
extern struct GC_Thread_Rep *GC_my_envp;
#    endif

#    define SGC_save_regvar() NULL /* dummy */
#    define SGC_restore_regvar(p) /* do nothing */
#    define SGC_EXPLICIT_INIT_LOCAL 0

#define DECLARE_MYENV
#define DECLARE_MYENV2
#define DECLARE_MYENV3
#define SGC_set_myenvp(p)
#define SGC_tlskey_create()

#  elif defined SGC_TLS_IMPORT_PUBLIC_FUNCTION || \
        defined SGC_TLS_IMPORT_EACH_FUNCTION

#    if defined SGC_TLS_IMPORT_EACH_FUNCTION
#      define GC_my_envp reg_my_envp
#define DECLARE_MYENV register struct GC_Thread_Rep *GC_my_envp = SGC_get_myenvp();
/* #define DECLARE_MYENV register struct GC_Thread_Rep *GC_my_envp = (GC_err_printf1("GETENV: "__FILE__":%d\n", __LINE__), SGC_get_myenvp()); */
#define DECLARE_MYENV2 register struct GC_Thread_Rep *GC_my_envp;
#define DECLARE_MYENV3
#    else /* SGC_TLS_IMPORT_PUBLIC_FUNCTION */
#      define GC_my_envp arg_my_envp
#define DECLARE_MYENV
#define DECLARE_MYENV2 register struct GC_Thread_Rep *GC_my_envp;
/* #define DECLARE_MYENV3 register struct GC_Thread_Rep *GC_my_envp = (GC_err_printf1("GETENV: "__FILE__":%d\n", __LINE__), SGC_get_myenvp()); */
#define DECLARE_MYENV3 register struct GC_Thread_Rep *GC_my_envp = SGC_get_myenvp();
#    endif

# if defined(__STDC__) || defined(__cplusplus)
struct GC_Thread_Rep *SGC_get_myenvp (void); 
#else
struct GC_Thread_Rep *SGC_get_myenvp ();
#endif
extern void SGC_set_myenvp(struct GC_Thread_Rep *);
extern void SGC_tlskey_create(void);

#    define SGC_save_regvar() NULL /* dummy */
#    define SGC_restore_regvar(p) /* do nothing */
#    define SGC_EXPLICIT_INIT_LOCAL 0

#  elif defined SGC_TLS_REGISTER_VARIABLE

#define DECLARE_MYENV
#define DECLARE_MYENV2
#define DECLARE_MYENV3
#define SGC_set_myenvp(p)
#define SGC_tlskey_create()

#    if defined SPARC
register struct GC_Thread_Rep *GC_my_envp asm ("%g6");
#    elif defined MIPS
register struct GC_Thread_Rep *GC_my_envp asm ("$23");
#    elif defined I386
register struct GC_Thread_Rep *GC_my_envp asm ("ebx");
#    endif

#    define SGC_save_regvar() (void*)GC_my_envp
#    define SGC_restore_regvar(p) {GC_my_envp = (struct GC_Thread_Rep *)p;}
#    define SGC_EXPLICIT_INIT_LOCAL 0

#  elif defined SGC_TLS_STHREADS_MODE

#    include <st.h>

/* In StackThreads mode, */
/*  %l7 register on SPARC */
/*  $23 register on MIPS */
/*  ebx register on Intel */
/* is implicitly reserved. */
#    define GC_my_envp (*(struct GC_Thread_Rep **)tls_user)

#    define SGC_save_regvar() (void*)__tls
#    define SGC_restore_regvar(p) {__tls = p;}
#    define SGC_EXPLICIT_INIT_LOCAL 1

#    define SGC_gcproc_init_hook() { \
  __tls = (struct thread_local_storage *) \
      GC_scratch_g_alloc(sizeof(struct thread_local_storage)); \
      }

#define DECLARE_MYENV
#define DECLARE_MYENV2
#define DECLARE_MYENV3
#define SGC_set_myenvp(p)
#define SGC_tlskey_create()

#  else
    --> unknown configuration (gc_tls.h)
#  endif

#if defined SGC_TLS_IMPORT_PUBLIC_FUNCTION
#define SGC_MYENV_ARG_DECL0 struct GC_Thread_Rep *GC_my_envp
#define SGC_MYENV_ARG0 GC_my_envp
#define SGC_MYENV_ARG_DECL1 struct GC_Thread_Rep *GC_my_envp,
#define SGC_MYENV_ARG1 GC_my_envp,
#define SGC_MYENV_ARG_DECL2 struct GC_Thread_Rep *GC_my_envp;
#else
#define SGC_MYENV_ARG_DECL0 void
#define SGC_MYENV_ARG0
#define SGC_MYENV_ARG_DECL1
#define SGC_MYENV_ARG1
#define SGC_MYENV_ARG_DECL2
#endif

