#ifndef PROTO_H
#define PROTO_H

/*   allchblk.c   */
void GC_print_hblkfreelist GC_PROTO((void));
struct hblk *GC_allochblk GC_PROTO((SGC_MYENV_ARG_DECL1 word sz, int kind, unsigned char flags));
struct hblk *GC_allochblk_inner GC_PROTO((SGC_MYENV_ARG_DECL1 word sz, int kind, unsigned char flags));
void GC_freehblk GC_PROTO((register struct hblk *p));

/*   alloc.c   */
GC_bool GC_never_stop_func GC_PROTO((void));
int GC_timeout_stop_func GC_PROTO((void));
word GC_adj_words_allocd GC_PROTO((void));
void GC_clear_a_few_frames GC_PROTO((void));
GC_bool GC_should_collect GC_PROTO((void));
void GC_add_to_heap GC_PROTO((SGC_MYENV_ARG_DECL1 struct hblk *p, word bytes));
void GC_print_heap_sects GC_PROTO((void));
ptr_t GC_max GC_PROTO((ptr_t x, ptr_t y));
ptr_t GC_min GC_PROTO((ptr_t x, ptr_t y));
void GC_set_max_heap_size GC_PROTO((GC_word n));
GC_bool GC_expand_hp_inner GC_PROTO((SGC_MYENV_ARG_DECL1 word n));
int GC_expand_hp GC_PROTO((size_t bytes));
void GC_gcollect GC_PROTO((void));
GC_bool GC_collect_or_expand GC_PROTO((SGC_MYENV_ARG_DECL1 word needed_blocks, GC_bool ignore_off_page));
GC_bool GC_collect_or_expand_inner GC_PROTO((SGC_MYENV_ARG_DECL1 word needed_blocks, GC_bool ignore_off_page));
ptr_t GC_allocobj GC_PROTO((SGC_MYENV_ARG_DECL1 word sz, int kind));

/*   blacklst.c   */
void GC_bl_init GC_PROTO((void));
int GC_test_and_set_pht_entry_from_index GC_PROTO((word *bl, int index));
void GC_clear_bl GC_PROTO((word *doomed));
void GC_copy_bl GC_PROTO((word *old, word *new));
void GC_promote_black_lists GC_PROTO((void));
void GC_unpromote_black_lists GC_PROTO((void));
void GC_add_to_black_list_normal GC_PROTO((word p));
void GC_add_to_black_list_stack GC_PROTO((word p));
struct hblk *GC_is_black_listed GC_PROTO((struct hblk *h, word len));
word GC_number_stack_black_listed GC_PROTO((struct hblk *start, struct hblk *endp1));

/*   blocksync.c   */
int GC_solaris_thread_blocksync_init GC_PROTO((sh_blocksync_t *bsp, int maxsem, int maxbar));
void GC_solaris_thread_blocksync_end GC_PROTO((sh_blocksync_t *bsp));
int GC_solaris_thread_bssem_init GC_PROTO((sh_bssem_t *semp, sh_blocksync_t *bsp));
void GC_solaris_thread_bssem_end GC_PROTO((sh_bssem_t *semp));
void GC_solaris_thread_bssem_clear GC_PROTO((sh_bssem_t *semp));
void GC_solaris_thread_bssem_signal GC_PROTO((sh_bssem_t *semp));
void GC_solaris_thread_bssem_wait GC_PROTO((sh_bssem_t *semp));
int GC_solaris_thread_bsbar_init GC_PROTO((sh_bsbar_t *barp, sh_blocksync_t *bsp, int np));
void GC_solaris_thread_bsbar_sync GC_PROTO((sh_bsbar_t *barp, int isleader));
void GC_solaris_thread_bsbar_end GC_PROTO((sh_bsbar_t *barp));
int GC_pthread_blocksync_init GC_PROTO((sh_blocksync_t *bsp, int maxsem, int maxbar));
void GC_pthread_blocksync_end GC_PROTO((sh_blocksync_t *bsp));
int GC_pthread_bssem_init GC_PROTO((sh_bssem_t *semp, sh_blocksync_t *bsp));
void GC_pthread_bssem_end GC_PROTO((sh_bssem_t *semp));
void GC_pthread_bssem_clear GC_PROTO((sh_bssem_t *semp));
void GC_pthread_bssem_signal GC_PROTO((sh_bssem_t *semp));
void GC_pthread_bssem_wait GC_PROTO((sh_bssem_t *semp));
int GC_pthread_bsbar_init GC_PROTO((sh_bsbar_t *barp, sh_blocksync_t *bsp, int np));
void GC_pthread_bsbar_sync GC_PROTO((sh_bsbar_t *barp, int isleader));
void GC_pthread_bsbar_end GC_PROTO((sh_bsbar_t *barp));
int GC_blocksync_init GC_PROTO((sh_blocksync_t *bsp, int maxsem, int maxbar));
void GC_blocksync_end GC_PROTO((sh_blocksync_t *bsp));
int GC_bssem_init GC_PROTO((sh_bssem_t *semp, sh_blocksync_t *bsp));
void GC_bssem_end GC_PROTO((sh_bssem_t *semp));
void GC_bssem_clear GC_PROTO((sh_bssem_t *semp));
void GC_bssem_signal GC_PROTO((sh_bssem_t *semp));
void GC_bssem_wait GC_PROTO((sh_bssem_t *semp));
int GC_bsbar_init GC_PROTO((sh_bsbar_t *barp, sh_blocksync_t *bsp, int np));
void GC_bsbar_sync GC_PROTO((sh_bsbar_t *barp, int isleader));
void GC_bsbar_end GC_PROTO((sh_bsbar_t *barp));

/*   checksums.c   */

/*   dbg_mlc.c   */
GC_bool GC_has_debug_info GC_PROTO((ptr_t p));
ptr_t GC_store_debug_info GC_PROTO((register ptr_t p, word sz, char *string, word integer));
/* ptr_t GC_check_annotated_obj GC_PROTO((register oh *ohdr)); */
void GC_print_obj GC_PROTO((ptr_t p));
void GC_print_smashed_obj GC_PROTO((ptr_t p, ptr_t clobbered_addr));
void GC_start_debugging GC_PROTO((void));
void GC_debug_register_displacement GC_PROTO((GC_word offset));
GC_PTR GC_debug_malloc GC_PROTO((size_t lb, char *s, int i));
GC_PTR GC_debug_malloc_atomic GC_PROTO((size_t lb, char *s, int i));
GC_PTR GC_debug_malloc_uncollectable GC_PROTO((size_t lb, char *s, int i));
GC_PTR GC_debug_malloc_atomic_uncollectable GC_PROTO((size_t lb, char *s, int i));
void GC_debug_free GC_PROTO((GC_PTR p));
GC_PTR GC_debug_realloc GC_PROTO((GC_PTR p, size_t lb, char *s, int i));
void GC_check_heap_block GC_PROTO((register struct hblk *hbp, word dummy));
void GC_check_heap_proc GC_PROTO((void));
void *GC_make_closure GC_PROTO((GC_finalization_proc fn, void *data));
void GC_debug_invoke_finalizer GC_PROTO((void *obj, void *data));

/*   demowin.c   */

/*   dyn_load.c   */
void GC_register_dynamic_libraries GC_PROTO((SGC_MYENV_ARG_DECL0));

/*   finalize.c   */
void GC_grow_table GC_PROTO((SGC_MYENV_ARG_DECL1 struct hash_chain_entry ***table, signed_word *log_size_ptr));
int GC_register_disappearing_link GC_PROTO((GC_PTR *link));
int GC_general_register_disappearing_link GC_PROTO((GC_PTR *link, GC_PTR obj));
int GC_unregister_disappearing_link GC_PROTO((GC_PTR *link));
void GC_normal_finalize_mark_proc GC_PROTO((ptr_t p));
void GC_ignore_self_finalize_mark_proc GC_PROTO((ptr_t p));
void GC_null_finalize_mark_proc GC_PROTO((ptr_t p));
void GC_register_finalizer_inner GC_PROTO((SGC_MYENV_ARG_DECL1 GC_PTR obj, GC_finalization_proc fn, GC_PTR cd, GC_finalization_proc *ofn, GC_PTR *ocd, finalization_mark_proc (*mp)));
void GC_register_finalizer GC_PROTO((void *obj, GC_finalization_proc fn, void *cd, GC_finalization_proc *ofn, void **ocd));
void GC_register_finalizer_ignore_self GC_PROTO((void *obj, GC_finalization_proc fn, void *cd, GC_finalization_proc *ofn, void **ocd));
void GC_register_finalizer_no_order GC_PROTO((SGC_MYENV_ARG_DECL1 void *obj, GC_finalization_proc fn, void *cd, GC_finalization_proc *ofn, void **ocd));
void GC_finalize_gc GC_PROTO((SGC_MYENV_ARG_DECL0));
int GC_invoke_finalizers GC_PROTO((void));
GC_PTR GC_call_with_alloc_lock GC_PROTO((GC_fn_type fn, GC_PTR client_data));

/*   gcc_support.c   */
void __default_new_handler GC_PROTO((void));
void *__builtin_new GC_PROTO((size_t size));
void *__builtin_vec_new GC_PROTO((size_t size));
void *__builtin_new_gc GC_PROTO((size_t size));
void *__builtin_new_gc_a GC_PROTO((size_t size));
void *__builtin_vec_new_gc GC_PROTO((size_t size));
void *__builtin_vec_new_gc_a GC_PROTO((size_t size));
/* void *__builtin_new_gc_dtor GC_PROTO((void *o, destructor_proc d)); */
/* void *__builtin_vec_new_gc_dtor GC_PROTO((void *first_elem, destructor_proc d, size_t element_size)); */
void __builtin_delete GC_PROTO((void *o));
void __builtin_vec_delete GC_PROTO((void *o));
void *_WeakPointer_New GC_PROTO((void *t));
/* void *_WeakPointer_Pointer GC_PROTO((WeakPointer *wp)); */
/* int _WeakPointer_Equal GC_PROTO((WeakPointer *wp1, WeakPointer *wp2)); */
/* int _WeakPointer_Hash GC_PROTO((WeakPointer *wp)); */
void _CleanUp_Set GC_PROTO((void *t, void (*c) (void *, void *), void *d));
void _CleanUp_Call GC_PROTO((void *t));
void *_CleanUp_Queue_NewHead GC_PROTO((void));
void _CleanUp_Queue_Set GC_PROTO((void *h, void *t));
int _CleanUp_Queue_Call GC_PROTO((void *h));

/*   headers.c   */
hdr *GC_find_header GC_PROTO((ptr_t h));
void GC_init_headers GC_PROTO((void));
GC_bool GC_install_header GC_PROTO((SGC_MYENV_ARG_DECL1 register struct hblk *h));
GC_bool GC_install_counts GC_PROTO((SGC_MYENV_ARG_DECL1 register struct hblk *h, register word sz));
void GC_remove_header GC_PROTO((register struct hblk *h));
void GC_remove_counts GC_PROTO((register struct hblk *h, register word sz));
void GC_apply_to_all_blocks GC_PROTO((void (*fn) (register struct hblk *hbp, word dummy), word client_data));
struct hblk *GC_next_block GC_PROTO((struct hblk *h));

/*   if_mach.c   */

/*   if_not_there.c   */

/*   loaddist.c   */
int GC_ld_init_local GC_PROTO((GC_thread envp));
int GC_ld_init_phase GC_PROTO((void));
int GC_push_overload GC_PROTO((SGC_MYENV_ARG_DECL0));
int GC_get_work_or_terminate GC_PROTO((SGC_MYENV_ARG_DECL0));

/*   mach_dep.c   */
void GC_push_regs GC_PROTO((void));

/*   malloc.c   */
ptr_t GC_generic_malloc_inner GC_PROTO((SGC_MYENV_ARG_DECL1 register word lb, register int k));
ptr_t GC_generic_malloc_inner_ignore_off_page GC_PROTO((SGC_MYENV_ARG_DECL1 register size_t lb, register int k));
ptr_t GC_generic_malloc_ignore_off_page GC_PROTO((SGC_MYENV_ARG_DECL1 register size_t lb, register int k));
void *GC_malloc_ignore_off_page GC_PROTO((size_t lb));
void *GC_malloc_atomic_ignore_off_page GC_PROTO((size_t lb));
ptr_t GC_generic_malloc GC_PROTO((SGC_MYENV_ARG_DECL1 register word lb, register int k));
ptr_t GC_generic_malloc_words_small GC_PROTO((SGC_MYENV_ARG_DECL1 register word lw, register int k));
ptr_t GC_generic_malloc_many GC_PROTO((SGC_MYENV_ARG_DECL1 register word lb, register int k));
void *GC_malloc_many GC_PROTO((SGC_MYENV_ARG_DECL1 size_t lb));
GC_PTR GC_malloc_atomic GC_PROTO((size_t lb));
GC_PTR GC_malloc GC_PROTO((size_t lb));
GC_PTR GC_malloc_uncollectable GC_PROTO((size_t lb));
GC_PTR GC_malloc_atomic_uncollectable GC_PROTO((size_t lb));
GC_PTR GC_generic_or_special_malloc GC_PROTO((SGC_MYENV_ARG_DECL1 word lb, int knd));
GC_PTR GC_realloc GC_PROTO((GC_PTR p, size_t lb));
void GC_free GC_PROTO((GC_PTR p));

/*   mark.c   */
void GC_noop GC_PROTO((void *dummy, ...));
void GC_noop1 GC_PROTO((word x));
int GC_init_obj_kinds GC_PROTO((void));
GC_bool GC_collection_in_progress GC_PROTO((SGC_MYENV_ARG_DECL0));
void GC_clear_hdr_marks GC_PROTO((register hdr *hhdr));
void GC_set_hdr_marks GC_PROTO((register hdr *hhdr));
void GC_set_mark_bit GC_PROTO((ptr_t p));
void GC_clear_mark_bit GC_PROTO((ptr_t p));
GC_bool GC_is_marked GC_PROTO((ptr_t p));
void GC_clear_marks GC_PROTO((SGC_MYENV_ARG_DECL0));
GC_bool GC_mark_some GC_PROTO((SGC_MYENV_ARG_DECL0));
GC_bool GC_mark_stack_empty GC_PROTO((SGC_MYENV_ARG_DECL0));
word GC_find_start GC_PROTO((register word current, register hdr *hhdr));
void GC_invalidate_mark_state GC_PROTO((SGC_MYENV_ARG_DECL0));
mse *GC_signal_mark_stack_overflow GC_PROTO((SGC_MYENV_ARG_DECL1 mse *msp));
void GC_mark_from_mark_stack GC_PROTO((SGC_MYENV_ARG_DECL0));
int GC_mark_stack_init GC_PROTO((GC_thread envp));
void GC_mark_stack_expand GC_PROTO((SGC_MYENV_ARG_DECL1 word n));
int GC_rootcopy_init GC_PROTO((GC_thread envp));
int GC_rootcopy_expand GC_PROTO((SGC_MYENV_ARG_DECL0));
void GC_push_all GC_PROTO((SGC_MYENV_ARG_DECL1 ptr_t bottom, ptr_t top));
void GC_emit_all GC_PROTO((SGC_MYENV_ARG_DECL1 ptr_t bottom, ptr_t top));
void GC_push_dirty GC_PROTO((SGC_MYENV_ARG_DECL1 ptr_t bottom, ptr_t top, int (*dirty_fn) (struct hblk * h), void (*push_fn) (SGC_MYENV_ARG_DECL1 ptr_t bottom, ptr_t top)));
void GC_push_conditional GC_PROTO((SGC_MYENV_ARG_DECL1 ptr_t bottom, ptr_t top, int all));
void GC_push_one GC_PROTO((word p));
void GC_push_one_checked GC_PROTO((SGC_MYENV_ARG_DECL1 register word p, register GC_bool interior_ptrs));
void GC_emit_one_checked GC_PROTO((SGC_MYENV_ARG_DECL1 register word p));
void GC_push_marked1 GC_PROTO((SGC_MYENV_ARG_DECL1 struct hblk *h, register hdr *hhdr));
void GC_push_marked2 GC_PROTO((SGC_MYENV_ARG_DECL1 struct hblk *h, register hdr *hhdr));
void GC_push_marked4 GC_PROTO((SGC_MYENV_ARG_DECL1 struct hblk *h, register hdr *hhdr));
void GC_push_marked GC_PROTO((SGC_MYENV_ARG_DECL1 struct hblk *h, register hdr *hhdr));
GC_bool GC_block_was_dirty GC_PROTO((struct hblk *h, register hdr *hhdr));
struct hblk *GC_push_next_marked GC_PROTO((SGC_MYENV_ARG_DECL1 struct hblk *h));
struct hblk *GC_push_next_marked_dirty GC_PROTO((SGC_MYENV_ARG_DECL1 struct hblk *h));
struct hblk *GC_push_next_marked_uncollectable GC_PROTO((SGC_MYENV_ARG_DECL1 struct hblk *h));

/*   mark_rts.c   */
void GC_print_static_roots GC_PROTO((SGC_MYENV_ARG_DECL0));
GC_bool GC_is_static_root GC_PROTO((SGC_MYENV_ARG_DECL1 ptr_t p));
struct roots *GC_roots_present GC_PROTO((char *b));
void GC_add_roots GC_PROTO((char *b, char *e));
void GC_add_roots_inner GC_PROTO((SGC_MYENV_ARG_DECL1 char *b, char *e, GC_bool tmp));
void GC_clear_roots GC_PROTO((void));
void GC_remove_tmp_roots GC_PROTO((SGC_MYENV_ARG_DECL0));
ptr_t GC_approx_sp GC_PROTO((void));
void GC_emit_roots GC_PROTO((SGC_MYENV_ARG_DECL0));
void GC_push_roots GC_PROTO((SGC_MYENV_ARG_DECL0));

/*   misc.c   */
void GC_init_size_map GC_PROTO((void));
void GC_extend_size_map GC_PROTO((word i));
ptr_t GC_clear_stack GC_PROTO((ptr_t arg));
GC_PTR GC_base GC_PROTO((GC_PTR p));
size_t GC_size GC_PROTO((GC_PTR p));
size_t GC_get_heap_size GC_PROTO((void));
size_t GC_get_bytes_since_gc GC_PROTO((void));
int GC_write GC_PROTO((int fd, char *buf, size_t len));
void GC_printf GC_PROTO((char *format, long int a, long int b, long int c, long int d, long int e, long int f));
void GC_err_printf GC_PROTO((char *format, long int a, long int b, long int c, long int d, long int e, long int f));
void GC_err_puts GC_PROTO((char *s));
void GC_default_warn_proc GC_PROTO((char *msg, GC_word arg));
GC_warn_proc GC_set_warn_proc GC_PROTO((GC_warn_proc p));
void GC_abort GC_PROTO((char *msg));
void GC_dump GC_PROTO((void));

/*   new_hblk.c   */
ptr_t GC_build_fl1 GC_PROTO((struct hblk *h, ptr_t ofl));
ptr_t GC_build_fl_clear2 GC_PROTO((struct hblk *h, ptr_t ofl));
ptr_t GC_build_fl_clear3 GC_PROTO((struct hblk *h, ptr_t ofl));
ptr_t GC_build_fl_clear4 GC_PROTO((struct hblk *h, ptr_t ofl));
ptr_t GC_build_fl2 GC_PROTO((struct hblk *h, ptr_t ofl));
ptr_t GC_build_fl4 GC_PROTO((struct hblk *h, ptr_t ofl));
void GC_new_hblk GC_PROTO((SGC_MYENV_ARG_DECL1 register word sz, int kind));

/*   obj_map.c   */
void GC_obj_map_init GC_PROTO((void));
void GC_invalidate_map GC_PROTO((hdr *hhdr));
void GC_register_displacement GC_PROTO((GC_word offset));
void GC_register_displacement_inner GC_PROTO((word offset));
GC_bool GC_add_map_entry GC_PROTO((word sz));

/*   os_dep.c   */
void GC_disable_signals GC_PROTO((void));
void GC_enable_signals GC_PROTO((void));
void GC_fault_handler GC_PROTO((int sig));
void GC_setup_temporary_fault_handler GC_PROTO((void));
void GC_reset_fault_handler GC_PROTO((void));
ptr_t GC_find_limit GC_PROTO((ptr_t p, GC_bool up));
ptr_t GC_get_stack_base GC_PROTO((void));
char *GC_SysVGetDataStart GC_PROTO((int max_page_size, int *etext_addr));
void GC_register_data_segments GC_PROTO((SGC_MYENV_ARG_DECL0));
ptr_t GC_unix_get_mem GC_PROTO((word bytes));
void GC_default_push_other_roots GC_PROTO((SGC_MYENV_ARG_DECL0));
void GC_or_pages GC_PROTO((word *pht1, word *pht2));
void GC_dirty_init GC_PROTO((SGC_MYENV_ARG_DECL0));
void GC_write_hint GC_PROTO((struct hblk *h));
void GC_read_dirty GC_PROTO((SGC_MYENV_ARG_DECL0));
GC_bool GC_page_was_dirty GC_PROTO((struct hblk *h));
GC_bool GC_page_was_ever_dirty GC_PROTO((struct hblk *h));
void GC_is_fresh GC_PROTO((struct hblk *h, word n));
#ifdef SAVE_CALL_CHAIN
void GC_save_callers GC_PROTO((struct callinfo *info));
word GC_save_regs_in_stack GC_PROTO((void));
#endif

/*   os_dep2.c   */
int GC_sh_processor_bind GC_PROTO((int procno));
#ifdef SAVE_CALL_CHAIN
void GC_print_callers GC_PROTO((struct callinfo *info));
#endif

/*   perfc_util.c   */
/* int PERFC_open GC_PROTO((PERFC_handler_t *hp, int e0, int e1)); */
/* int PERFC_read GC_PROTO((PERFC_handler_t *hp, PERFC_counter_t *pc0, PERFC_counter_t *pc1)); */
/* int PERFC_close GC_PROTO((PERFC_handler_t *hp)); */

/*   ptr_chck.c   */
void GC_default_same_obj_print_proc GC_PROTO((ptr_t p, ptr_t q));
GC_PTR GC_same_obj GC_PROTO((register void *p, register void *q));
void GC_default_is_valid_displacement_print_proc GC_PROTO((ptr_t p));
void *GC_is_valid_displacement GC_PROTO((void *p));
void GC_default_is_visible_print_proc GC_PROTO((ptr_t p));
GC_bool GC_on_stack GC_PROTO((ptr_t p));
void *GC_is_visible GC_PROTO((void *p));
GC_PTR GC_pre_incr GC_PROTO((GC_PTR *p, size_t how_much));
GC_PTR GC_post_incr GC_PROTO((GC_PTR *p, size_t how_much));

/*   real_malloc.c   */

/*   reclaim.c   */
ptr_t GC_yield_freelist_inner GC_PROTO((ptr_t p, ptr_t *gflp));
void GC_yield_freelist GC_PROTO((GC_thread envp));
GC_bool GC_block_empty GC_PROTO((register hdr *hhdr));
ptr_t GC_reclaim_clear GC_PROTO((register struct hblk *hbp, register hdr *hhdr, register word sz, register ptr_t list, GC_bool abort_if_found));
ptr_t GC_reclaim_clear2 GC_PROTO((register struct hblk *hbp, hdr *hhdr, register ptr_t list, GC_bool abort_if_found));
ptr_t GC_reclaim_clear4 GC_PROTO((register struct hblk *hbp, hdr *hhdr, register ptr_t list, GC_bool abort_if_found));
ptr_t GC_reclaim_uninit GC_PROTO((register struct hblk *hbp, register hdr *hhdr, register word sz, register ptr_t list, GC_bool abort_if_found));
ptr_t GC_reclaim_uninit2 GC_PROTO((register struct hblk *hbp, hdr *hhdr, register ptr_t list, GC_bool abort_if_found));
ptr_t GC_reclaim_uninit4 GC_PROTO((register struct hblk *hbp, hdr *hhdr, register ptr_t list, GC_bool abort_if_found));
ptr_t GC_reclaim1 GC_PROTO((register struct hblk *hbp, hdr *hhdr, register ptr_t list, GC_bool abort_if_found));
void GC_reclaim_small_nonempty_block GC_PROTO((SGC_MYENV_ARG_DECL1 register struct hblk *hbp, int abort_if_found));
void GC_reclaim_block GC_PROTO((SGC_MYENV_ARG_DECL1 register struct hblk *hbp, word abort_if_found));
int GC_n_set_marks GC_PROTO((hdr *hhdr));
void GC_print_block_descr GC_PROTO((struct hblk *h, word dummy));
void GC_print_block_list GC_PROTO((void));
ptr_t GC_sh_after_marksweep_local GC_PROTO((ptr_t, ptr_t, ptr_t));
void GC_continue_reclaim GC_PROTO((SGC_MYENV_ARG_DECL1 word sz, int kind));
void GC_continue_reclaim_g GC_PROTO((SGC_MYENV_ARG_DECL1 word sz, int kind));
void GC_yield_reclaim_list GC_PROTO((GC_thread envp));
void GC_yield_block GC_PROTO((struct hblk *hbp, word data));
void GC_yield_all_blocks GC_PROTO((GC_thread envp));
void GC_reclaim_or_delete_all GC_PROTO((SGC_MYENV_ARG_DECL0));

/*   scralloc.c   */
ptr_t GC_sh_shm_alloc GC_PROTO((int shm_size, struct shm_handler *hp));
int GC_sh_get_mem_init GC_PROTO((int shm_size));
ptr_t GC_sh_get_mem GC_PROTO((word bytes));
ptr_t GC_sh_get_mem_untouched GC_PROTO((word bytes));
int GC_sh_get_mem_end GC_PROTO((void));
int GC_check_shm_roundrobin GC_PROTO((SGC_MYENV_ARG_DECL0));
int GC_scratch_alloc_init GC_PROTO((struct scratch *scratchp));
ptr_t GC_scratch_generic_alloc GC_PROTO((register word bytes, struct scratch *scratchp));
ptr_t GC_scratch_alloc GC_PROTO((SGC_MYENV_ARG_DECL1 register word bytes));
ptr_t GC_scratch_g_alloc GC_PROTO((register word bytes));

/*   setjmp_t.c   */
int getpagesize GC_PROTO((void));
int *nested_sp GC_PROTO((void));
int g GC_PROTO((int x));

/*   shared.c   */
void GC_sh_stop_handler GC_PROTO((int));
void GC_sh_error_handler GC_PROTO((int));
void GC_sh_int_handler GC_PROTO((int));
int GC_setup_debug_handler GC_PROTO((void));
int GC_setup_stop_handler GC_PROTO((void));
void PSM_mutex_lock_polling_inner GC_PROTO((SGC_MYENV_ARG_DECL1 PSM_mutex_t *mutex_p, void (*polling_func) (SGC_MYENV_ARG_DECL0)));
int GC_notify_async_to_appproc GC_PROTO((GC_thread envp));
int GC_notify_async_to_all_appprocs GC_PROTO((SGC_MYENV_ARG_DECL1 GC_bool exceptme));
int GC_awake_proc GC_PROTO((GC_thread envp));
int GC_awake_all_procs GC_PROTO((struct envp_list *list));
int GC_awake_all_appprocs GC_PROTO((void));
int GC_awake_all_gcprocs GC_PROTO((void));
void GC_proc_envps_init GC_PROTO((struct envp_list *list));
void GC_appproc_envps_init GC_PROTO((void));
void GC_gcproc_envps_init GC_PROTO((void));
int GC_count_proc_envps GC_PROTO((struct envp_list *list));
int GC_count_appproc_envps GC_PROTO((void));
int GC_count_gcproc_envps GC_PROTO((void));
int GC_is_appproc_envps_empty GC_PROTO((void));
int GC_is_gcproc_envps_empty GC_PROTO((void));
int GC_is_appproc_envp_head GC_PROTO((GC_thread envp));
int GC_is_gcproc_envp_head GC_PROTO((GC_thread envp));
int GC_add_proc_envp GC_PROTO((struct envp_list *list, GC_thread envp));
int GC_add_appproc_envp GC_PROTO((GC_thread envp));
int GC_add_gcproc_envp GC_PROTO((GC_thread envp));
GC_thread GC_lookup_proc_envp GC_PROTO((struct envp_list *list, GC_thread_id pid));
GC_thread GC_lookup_appproc_envp GC_PROTO((GC_thread_id pid));
GC_thread GC_lookup_gcproc_envp GC_PROTO((GC_thread_id pid));
int GC_remove_proc_envp GC_PROTO((struct envp_list *list, GC_thread removep));
int GC_remove_appproc_envp GC_PROTO((GC_thread removep));
int GC_remove_gcproc_envp GC_PROTO((GC_thread removep));
GC_thread GC_alloc_env GC_PROTO((void));
int GC_init_proc_common GC_PROTO((GC_thread envp));
int GC_init_gcenv GC_PROTO((GC_thread envp));
void GC_gcproc_mainloop GC_PROTO((SGC_MYENV_ARG_DECL0));
int GC_alloc_flrl GC_PROTO((GC_thread envp, int ok));
int GC_alloc_grl GC_PROTO((int ok));
int GC_init_appenv GC_PROTO((GC_thread envp));
GC_thread GC_init_appproc GC_PROTO((ptr_t my_stackbottom, int detached));
GC_thread GC_init_gcproc GC_PROTO((void));
GC_thread GC_init_spmdproc GC_PROTO((ptr_t my_stackbottom, int detached));
void *GC_gcproc_wrapper GC_PROTO((void *arg));
int GC_create_gcprocs GC_PROTO((int n_gcprocs));
int GC_kill_gcprocs GC_PROTO((void));
GC_thread GC_process_creation_hook GC_PROTO((ptr_t my_stackbottom, int detached));
int GC_setup_stop_handler GC_PROTO((void));
void GC_reset_stop_handler GC_PROTO((void));
int GC_setup_debug_handler GC_PROTO((void));
void GC_reset_debug_handler GC_PROTO((void));
int GC_system_init GC_PROTO((int n_gcprocs, SGC_attr_t *attr));
int SGC_attr_init GC_PROTO((SGC_attr_t *attr));
int SGC_init GC_PROTO((int n_gcprocs, SGC_attr_t *attr));
void SGC_disable_stop_world GC_PROTO((void));
void SGC_enable_stop_world GC_PROTO((void));
int SGC_init_local GC_PROTO((void));
int GC_terminate_proc GC_PROTO((GC_thread_id pid));
int SGC_finalize_log GC_PROTO((void));
void GC_sh_exitfunc GC_PROTO(());
int GC_system_terminate GC_PROTO((void));
int GC_cleanup_finished_detached_procs GC_PROTO(());
void GC_emit_all_stack GC_PROTO((SGC_MYENV_ARG_DECL0));
int GC_gcwork_by_appproc GC_PROTO((SGC_MYENV_ARG_DECL1 GC_bool invoker));
int GC_gcwork_by_spmdproc GC_PROTO((SGC_MYENV_ARG_DECL1 GC_bool invoker));
void GC_async_work GC_PROTO((SGC_MYENV_ARG_DECL0));
void GC_sh_stop_handler GC_PROTO((int sig));
void GC_sh_error_handler GC_PROTO((int sig));
void GC_sh_int_handler GC_PROTO((int sig));
void SGC_polling_inner GC_PROTO((SGC_MYENV_ARG_DECL0));
void SGC_polling GC_PROTO((void));
int GC_clear_app_counters GC_PROTO((SGC_MYENV_ARG_DECL0));
int GC_sumup_app_counters GC_PROTO((void));
int GC_sumup_gc_counters GC_PROTO((void));
int GC_lock_all_la_alloc GC_PROTO((SGC_MYENV_ARG_DECL0));
int GC_unlock_all_la_alloc GC_PROTO((SGC_MYENV_ARG_DECL0));
int SGC_gcollect_inner GC_PROTO((SGC_MYENV_ARG_DECL0));
void GC_stopped_mark_init_local GC_PROTO((SGC_MYENV_ARG_DECL0));
ptr_t GC_stopped_mark_local GC_PROTO((SGC_MYENV_ARG_DECL0));
int GC_marksweep_local GC_PROTO((SGC_MYENV_ARG_DECL0));
int GC_sh_dummy GC_PROTO((int s));
int GC_touch_memory_region GC_PROTO((char *ptr, size_t size));
int GC_dump_list_stat GC_PROTO((void));
int GC_dump_freelist GC_PROTO((GC_thread envp));
void GC_debug_print_envp GC_PROTO((SGC_MYENV_ARG_DECL0));
void GC_set_debug_state GC_PROTO((SGC_MYENV_ARG_DECL1 int ds));
GC_thread GC_debug_get_envp GC_PROTO((SGC_MYENV_ARG_DECL0));
int GC_debug_call_chain GC_PROTO((void));

/*   sharedlog.c   */
int GC_gcrlog_put_mark GC_PROTO((int));
int GC_gcrlog_put_sweep GC_PROTO((int));
int GC_marklog_init GC_PROTO((void));
int GC_marklog_init_local GC_PROTO((GC_thread envp));
int GC_marklog_init_phase GC_PROTO((void));
int GC_marklog_start_clock GC_PROTO((void));
int GC_marklog_put GC_PROTO((SGC_MYENV_ARG_DECL1 int kind, int count));
int GC_marklog_stop_clock GC_PROTO((void));
int GC_marklog_end_phase GC_PROTO((void));
int GC_gcrlog_init GC_PROTO((void));
int GC_gcrlog_end GC_PROTO((void));
int GC_gcrlog_put_mark GC_PROTO((int us));
int GC_gcrlog_put_sweep GC_PROTO((int us));
int GC_gcrlog_init_gc GC_PROTO((void));
void GC_gcrlog_set_clock GC_PROTO((int i));
int GC_gcrlog_end_gc GC_PROTO((void));

/*   sreclaim.c   */
#ifdef FIND_LEAK
void GC_flush_temp_flist GC_PROTO((SGC_MYENV_ARG_DECL1 hdr *hhdr));
#endif
void GC_hbiter_init_index GC_PROTO((bottom_index *index_p));
int GC_hbiter_start GC_PROTO((void));
SH_HBCHUNK *GC_hbiter_get GC_PROTO((void));
int GC_hbiter_end GC_PROTO((void));
void GC_dump_chunk GC_PROTO((SH_HBCHUNK *chunkp));
void GC_remove_header_local GC_PROTO((register struct hblk *h, register SH_HBCHUNK *chunkp));
int GC_coalesce_or_link GC_PROTO((struct hblk *p1, struct hblk *p2));
void GC_link_to_hblkfl_local GC_PROTO((SGC_MYENV_ARG_DECL1 register struct hblk *p));
void GC_freehblk_local GC_PROTO((SGC_MYENV_ARG_DECL1 register struct hblk *p));
void GC_link_my_chunk GC_PROTO((SGC_MYENV_ARG_DECL0));
void GC_flush_temp_rlist GC_PROTO((SGC_MYENV_ARG_DECL0));
void GC_clear_lists_proc GC_PROTO((GC_thread envp));
void GC_clear_lists_local GC_PROTO((SGC_MYENV_ARG_DECL0));
void GC_start_reclaim_local GC_PROTO((SGC_MYENV_ARG_DECL0));
int GC_make_hblkfl GC_PROTO((void));

/*   stubborn.c   */
void GC_end_stubborn_change GC_PROTO((GC_PTR));
void GC_debug_end_stubborn_change GC_PROTO((GC_PTR));
GC_PTR GC_malloc_stubborn GC_PROTO((size_t lb));
void GC_end_stubborn_change GC_PROTO((GC_PTR p));
void GC_change_stubborn GC_PROTO((GC_PTR p));

/*   thrpkg.c   */
/* struct appproc_entry *GC_alloc_appproc_entry GC_PROTO((void)); */
GC_thread_id GC_sh_solaris_thread_getpid GC_PROTO((void));
int GC_sh_solaris_thread_sendsig GC_PROTO((GC_thread_id pid, int sig));
int GC_sh_solaris_thread_is_signalhandler_separate GC_PROTO((void));
int GC_sh_solaris_thread_wait GC_PROTO((GC_thread_id pid));
GC_thread_id GC_sh_solaris_thread_create_process GC_PROTO((void *(*func) (void *), void *arg));
void GC_sh_solaris_thread_exit_process GC_PROTO((void));
void *SGC_solaris_thread_wrapper GC_PROTO((void *dummyarg));
int SGC_thr_create GC_PROTO((void *stack_base, size_t stack_size, void *(*start_func) (void *), void *arg, long int flags, void *nt));
int GC_sh_solaris_thread_setconcurrency GC_PROTO((int n));
GC_thread_id GC_sh_pthread_getpid GC_PROTO((void));
int GC_sh_pthread_sendsig GC_PROTO((GC_thread_id pid, int sig));
int GC_sh_pthread_is_signalhandler_separate GC_PROTO((void));
int GC_sh_pthread_wait GC_PROTO((GC_thread_id pid));
GC_thread_id GC_sh_pthread_create_process GC_PROTO((void *(*func) (void *), void *arg));
void GC_sh_pthread_exit_process GC_PROTO((void));
void *SGC_pthread_wrapper GC_PROTO((void *dummyarg));
int SGC_pthread_create GC_PROTO((void *nt, void *pa, void *(*start_func) (void *), void *arg));
int GC_sh_pthread_setconcurrency GC_PROTO((int n));
int GC_sh_setconcurrency GC_PROTO((int));
int GC_thrpkg_init GC_PROTO((int n_gcprocs));
GC_thread_id GC_sh_getpid GC_PROTO((void));
int GC_sh_sendsig GC_PROTO((GC_thread_id pid, int sig));
int GC_sh_is_signalhandler_separate GC_PROTO((void));
int GC_sh_wait GC_PROTO((GC_thread_id pid));
GC_thread_id GC_sh_create_process GC_PROTO((void *(*func) (void *), void *arg));
void GC_sh_exit_process GC_PROTO((void));
int GC_sh_setconcurrency GC_PROTO((int n));
int SGC_create_process GC_PROTO((void *(*func) (void *), void *arg));
int SGC_wait_process GC_PROTO((int pid));
GC_thread SGC_get_myenvp GC_PROTO((void));
void SGC_set_myenvp GC_PROTO((GC_thread envp));
void SGC_tlskey_create GC_PROTO((void));

/*   typd_mlc.c   */
/* signed_word GC_add_ext_descriptor GC_PROTO((GC_bitmap bm, word nbits)); */
/* GC_descr GC_double_descr GC_PROTO((register GC_descr descriptor, register word nwords)); */
/* int GC_make_array_descriptor GC_PROTO((word nelements, word size, GC_descr descriptor, GC_descr *simple_d, complex_descriptor **complex_d, struct LeafDescriptor *leaf)); */
/* complex_descriptor *GC_make_sequence_descriptor GC_PROTO((complex_descriptor *first, complex_descriptor *second)); */
void GC_init_explicit_typing GC_PROTO((SGC_MYENV_ARG_DECL0));
mse *GC_typed_mark_proc GC_PROTO((SGC_MYENV_ARG_DECL1 register word *addr, register mse *mark_stack_ptr, mse *mark_stack_limit, word env));
/* word GC_descr_obj_size GC_PROTO((register complex_descriptor *d)); */
/* mse *GC_push_complex_descriptor GC_PROTO((word *addr, register complex_descriptor *d, register mse *msp, mse *msl)); */
mse *GC_array_mark_proc GC_PROTO((SGC_MYENV_ARG_DECL1 register word *addr, register mse *mark_stack_ptr, mse *mark_stack_limit, word env));
/* GC_descr GC_make_descriptor GC_PROTO((GC_bitmap bm, size_t len)); */
/* void *GC_malloc_explicitly_typed GC_PROTO((size_t lb, GC_descr d)); */
/* void *GC_calloc_explicitly_typed GC_PROTO((size_t n, size_t lb, GC_descr d)); */

#endif /* !PROTO_H */
